"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  getDiff: () => getDiff
});
module.exports = __toCommonJS(src_exports);

// src/diff.ts
var import_graphql = require("graphql");
var import_lexicographicSortSchema = require("graphql/utilities/lexicographicSortSchema.js");
var import_disparity = __toESM(require("disparity"), 1);
var import_load = require("@graphql-tools/load");
var import_url_loader = require("@graphql-tools/url-loader");
var import_json_file_loader = require("@graphql-tools/json-file-loader");
var import_utils = require("@graphql-tools/utils");
var import_graphql_file_loader = require("@graphql-tools/graphql-file-loader");
var import_node_fetch = __toESM(require("node-fetch"), 1);
async function getDiff(leftSchemaLocation, rightSchemaLocation, options = {}) {
  const getSchemaOptions = (customHeaders) => ({
    headers: { ...options.headers, ...customHeaders },
    skipGraphQLImport: false,
    descriptions: false,
    customFetch: import_node_fetch.default,
    inputValueDeprecation: options.inputValueDeprecation
  });
  const leftSchemaOptions = getSchemaOptions(options.leftSchema?.headers);
  const rightSchemaOptions = getSchemaOptions(options.rightSchema?.headers);
  let [leftSchema, rightSchema] = await Promise.all([
    (0, import_load.loadSchema)(leftSchemaLocation, {
      loaders: [new import_url_loader.UrlLoader(), new import_json_file_loader.JsonFileLoader(), new import_graphql_file_loader.GraphQLFileLoader()],
      ...leftSchemaOptions
    }),
    (0, import_load.loadSchema)(rightSchemaLocation, {
      loaders: [new import_url_loader.UrlLoader(), new import_json_file_loader.JsonFileLoader(), new import_graphql_file_loader.GraphQLFileLoader()],
      ...rightSchemaOptions
    })
  ]);
  if (!leftSchema || !rightSchema) {
    throw new Error("Schemas not defined");
  }
  if (options.sortSchema) {
    [leftSchema, rightSchema] = [
      (0, import_lexicographicSortSchema.lexicographicSortSchema)(leftSchema),
      (0, import_lexicographicSortSchema.lexicographicSortSchema)(rightSchema)
    ];
  }
  const [leftSchemaSDL, rightSchemaSDL] = [
    (0, import_utils.printSchemaWithDirectives)(leftSchema),
    (0, import_utils.printSchemaWithDirectives)(rightSchema)
  ];
  if (leftSchemaSDL === rightSchemaSDL) {
    return;
  }
  const diff = import_disparity.default.unified(leftSchemaSDL, rightSchemaSDL, {
    paths: [leftSchemaLocation, rightSchemaLocation]
  });
  const diffNoColor = import_disparity.default.unifiedNoColor(leftSchemaSDL, rightSchemaSDL, {
    paths: [leftSchemaLocation, rightSchemaLocation]
  });
  const dangerousChanges = (0, import_graphql.findDangerousChanges)(leftSchema, rightSchema);
  const breakingChanges = (0, import_graphql.findBreakingChanges)(leftSchema, rightSchema);
  return {
    diff,
    diffNoColor,
    dangerousChanges,
    breakingChanges
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getDiff
});
//# sourceMappingURL=index.cjs.map